<?php

/**
 * inf_gen_termina_contrato actions.
 *
 * @package    nomina
 * @subpackage inf_gen_termina_contrato
 * @author     Manuel Enrique Paredes Lopez
 * @email       mparedes@sofhouse.net
 * @fecha       22/12/2020
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class inf_gen_termina_contratoActions extends sfActions {

    /**
     * Executes list action
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Paginacion
         */
        if (isset($request['_startRow'])) {
            $rowStart = $request['_startRow'];
        } else {
            $rowStart = 0;
        }

        if (isset($request['_endRow'])) {
            $rowEnd = $request['_endRow'];
        } else {
            $rowEnd = 75;
        }
        //ordenar consulta
        if (isset($request['_sortBy'])) {
            $sortBy = " Order by " . $request['_sortBy'];
        } else {
            $sortBy = 'order by num_doc';
        }


        /*
         * Manejo de errores
         */
        try {


            /*
             * Variables opcionales
             */
            //funcionario
            if (isset($request['num_doc'])) {
                $whereFuncionarioNumDoc = " AND tab0.num_doc = " . $request['num_doc'];
            } else {
                $whereFuncionarioNumDoc = ' ';
            }
            //funcionario
            if (isset($request['id_tipo_doc'])) {
                $whereFuncionarioTipoDoc = " AND tab0.id_tipo_doc = " . $request['id_tipo_doc'];
            } else {
                $whereFuncionarioTipoDoc = ' ';
            }
            //estado
            if (isset($request['estado']) && $request['estado'] == 'true') {
                $whereEstado = " AND tab0.estado = 1 ";
            } else if (isset($request['estado']) && $request['estado'] == '0') {
                $whereEstado = " AND tab0.estado = 0 ";
            } else if (isset($request['estado']) && $request['estado'] == 'false') {
                $whereEstado = " AND tab0.estado IN (0,1)";
            } else {
                $whereEstado = ' ';
            }

            $whereFecha = "";
            if (isset($request['fecha_ini']) && isset($request['fecha_fin'])) {
                $whereFecha = "AND tab0.fecha_termina BETWEEN to_date('" . $request['fecha_ini'] . "','yyyy-mm-dd') AND to_date('" . $request['fecha_fin'] . "','yyyy-mm-dd')";
            }

            $whereSituaNivelDos = "";
            if (isset($request['id_sa_niv2'])) {
                $whereSituaNivelDos = "AND tab0.id_sa_niv2 =" . $request['id_sa_niv2'];
            }

            $whereClasePlanta = "";
            if (isset($request['id_clase_planta'])) {
                $whereClasePlanta = "AND tab0.id_clase_planta = " . $request['id_clase_planta'];
            }


            //sentencia sql
            $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;
            //ejecuta y obtiene el resultado del sql
            CN_TABLE::executeSQL($sql);


            /**
             * Consulta para el informe terminación de contrato
             */
            $consulta_sql = <<<EOD
select
clapla.codigo as codigo_clapla,
clapla.descripcion as descripcion_clapla,
tab0.*,
tab1.nombre_completo,
tab1.num_doc as documento,
tab1.nombre_apellido as nombre_apellido,
tab2.centro,tab2.area,tab2.naturaleza,
rh_dp.codigo,
tab2.componente,
tab3.nombre,
tab4.id_anhos,tab4.id_meses,
tab5.descripcion,
tab2.asignacion_basica AS ASIGNA_BASICA2,

tabact.codigo as codigo_actual,
tabact.componente as componente_actual

from no_nombramiento tab0

left join no_datos_funcionario_v tab1 ON tab1.id_tipo_doc = tab0.id_tipo_doc and tab1.num_doc = tab0.num_doc

left join NO_DP_V tab2 ON tab2.id_dp = tab0.id_dp

left join rh_dp rh_dp ON tab2.id_dp = rh_dp.id_dp

left join RH_SA_NIV2 tab3 ON tab3.id_sa_niv2 = tab0.id_sa_niv2

left join NO_PERIODO tab4 ON tab4.id_periodo = tab0.id_periodo

left join NO_TIPO_PERIODO tab5 ON tab5.id_tipo_periodo = tab4.id_tipo_periodo

left join no_clase_planta clapla on clapla.id_clase_planta = tab0.id_clase_planta

left join (
    select distinct tab.* from(
        SELECT
        tab0.*,
        ROW_NUMBER() OVER (
        partition by tab0.num_doc
            ORDER BY tab0.num_doc, tab0.id_anhos desc, tab0.id_meses desc 
        ) AS rn
        from no_estado_func tab0
        join no_periodo per on per.id_periodo = tab0.periodo
        where 
        per.id_tipo_periodo = 1
    ) tab
    where  tab.rn = 1
)cargoact
ON cargoact.id_tipo_doc = tab0.id_tipo_doc and cargoact.num_doc = tab0.num_doc

left join NO_DP_V tabact ON tabact.id_dp = cargoact.id_dp


where 1=1
$whereFecha
$whereFuncionarioNumDoc $whereFuncionarioTipoDoc
$whereSituaNivelDos
$whereEstado 
$whereClasePlanta


ORDER BY 
tab3.nombre, 
tab0.id_tipo_doc, 
tab0.num_doc, 
tab0.fecha_ingreso  
EOD;

            /*
             * Sql que trae los resultados
             * por los filtros, para totalizar las filas
             */
            $sql = <<<EOD
select count(*) as count from (

select 
tab0.*
from(
    
    $consulta_sql

)tab0
                    
where
1 = 1     

                    
)
EOD;

            $total_record_count = CN_TABLE::executeSQL($sql);
            $total_record_count = $total_record_count[0]["count"];


            //obtener el listado de recaudos
            $sql = <<<EOD
SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (

select 
tab0.*
from(
    
    $consulta_sql

)tab0
                    
where
1 = 1                       
$sortBy
          
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart
EOD;
            //ejecuta y obtiene el resultado del sql
            $resultado = CN_TABLE::executeSQL($sql);


            $this->totalRows = $total_record_count;
            $this->startRow = $rowStart;
            $this->endRow = $rowStart + count($resultado);
            $this->list_data = $resultado;
            $this->logMessage("[inf_gen_termina_contrato] Consulta exitosa.");
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

}
